<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_ErrorCmd.php,v 1.5 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEB画面エラー表示クラス
 *
 * エラーメッセージ表示パターン
 * ○手動エラー1
 *   共通エラー画面表示
 *   end( 'エラーメッセージ' )
 * 
 * ○手動エラー2
 *   共通エラー画面にエラーメッセージを蓄えて、一気に表示
 *   …
 *   end(エラーメッセージオブジェクト)
 * 
 * ○自動エラー
 *   エラーハンドラ
 *   共通エラー画面表示後、終了
 * 
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_ErrorCmd.php,v 1.5 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_ErrorCmd extends SyL_Error
{
    /**
     * エラーハンドラーの実体
     * 
     * @access protected
     */
    function errorHandler()
    {
        // バッファリングクリア
        // ※必須
        ob_clean();

        // エラーメッセージ取得
        $error_message = implode($this->eof, $this->getErrorMessages()) . $this->eof;
        // エラータイプの取得
        $error_type  = $this->getErrorType();
        // エラートレースの取得
        $error_trace = SYL_ERROR_TRACE ? $this->getTraceConsole() : '';
        // エラーメッセージ取得
        $error_string = SYL_ERROR ? "[{$error_type}] {$error_message}" : SYL_ERROR_MESSAGE;
        // エラーメッセージ表示
        $this->displayErrorDefault($error_string, $error_trace);
        // ロギング
        $this->logging();
    }

    /**
     * デフォルトエラー画面生成
     *
     * @access private
     * @param string エラーメッセージ
     * @param string エラートレース
     */
    function displayErrorDefault($error_string, $error_trace)
    {
        echo $error_string;
        if ($error_trace) {
            echo $this->eof;
            echo $error_trace;
        }
    }

    /**
     * エラートレースを取得
     *
     * @access public
     * @return string エラートレース
     */
    function getTraceConsole()
    {
        $error_trace = $this->getTrace();
        $i = count($error_trace);
        $error_trace_result = '';
        if ($i > 0) {
            // エラートレース表示の作成
            $error_trace_result .= "------ start Debug Trace ------" . $this->eof;
            foreach ($error_trace as $value) {
                if (($value['function'] == '') || ($value['function'] == 'unknown')) {
                    $value['function'] = '';
                }
                if ($value['file'] == '') {
                    $value['file'] = '-';
                }
                if ($value['line'] == '') {
                    $value['line'] = '-';
                }
                $error_trace_result .= "{$i}. [file] {$value['file']} [line] {$value['line']} [function] {$value['function']}" . $this->eof;
                $i--;
            }
            $error_trace_result .= "------ end Debug Trace ------" . $this->eof;
        }

        return $error_trace_result;
    }
}
?>
